/*
 * PWM.h
 *
 *  Created on: 23 Jul 2019
 *      Author: kentm
 */

#ifndef PWM_H_
#define PWM_H_
// ******************** includes **********************************************
#include <stdint.h>
#include "stm32f4xx.h"
#include "stm32f4xx_tim.h"

// ******************** typedefs and defines **********************************
#define TIMXRCC_APB1Periph		(RCC_APB1Periph_TIM2 | RCC_APB1Periph_TIM5)
#define TIM2_GPIO_PORT1			   GPIOA
#define TIM2_GPIO_PORT2			   GPIOB
#define TIM2_AHB1				       (RCC_AHB1Periph_GPIOA | RCC_AHB1Periph_GPIOB)
#define TIM2_AF_PORT			     GPIO_AF_TIM2
#define TIM2CH1_Source			   GPIO_PinSource5	//A5
#define TIM2CH3_Source			   GPIO_PinSource10 //B10

#define TIM5_GPIO_PORT			   GPIOA
#define TIM5_AHB1				   		 RCC_AHB1Periph_GPIOA
#define TIM5_AF_PORT			   	 GPIO_AF_TIM3
#define TIM5CH1_Source			   GPIO_PinSource0 // A0
#define TIM5CH2_Source			   GPIO_PinSource1 // A1
#define TIM5CH3_Source			   GPIO_PinSource2 // A2
#define TIM5CH4_Source			   GPIO_PinSource3 // A3

#define TIMER_PERIOD50HZ           60000
#define TIMER_PERIOD490HZ          6122
#define TIMER_PRESCALER            32
#define RCPWM_PERIOD50HZ_uS        20000
#define RCPWM_PERIOD490HZ_uS       2040
#define RCPWM_MIN_uS           		 1000
#define RCPWM_NEUTRAL_uS           1500
#define RCPWM_RANGE_uS             1000
typedef enum{
	PWM_Freq50Hz=0,
	PWM_Freq490Hz,
	PWM_FreqLast
}PWM_Freq_t;
static inline uint32_t uS_to_ticks(uint32_t uS)
{
	return (uS * TIMER_PERIOD50HZ) / RCPWM_PERIOD50HZ_uS;
}
// ******************** exported function prototypes **************************
void PWMInit(void);
void PWMSetFreq(TIM_TypeDef* TIMx, uint8_t ch,PWM_Freq_t PWM_Freq);// set frequency, note all in timer group will be set to highest if any are set
void TIM_SetCompare(TIM_TypeDef* TIMx, uint8_t ch, uint32_t Compare);
// ******************** end of PWM.h *********************************** 	
#endif /* PWM_H_ */
