/*
 * Que.h
 *
 *  Created on: 15 Aug 2019
 *      Author: kentm
 */

#ifndef QUE_H_
#define QUE_H_
// ******************** includes **********************************************
#include <stdint.h>
#include <stdbool.h>
// ******************** typedefs and defines **********************************
typedef struct{
	uint8_t *Buffer;							// buffer pointer
	uint16_t Len;									// size of buffer
	uint16_t insert;							// insert location (internal use only)
	uint16_t remove;							// remove location (internal use only)
} Q_t;
// ******************** exported function prototypes **************************
static inline void VarInitQ(Q_t *Q,uint16_t QLen){Q->insert=Q->remove=0;Q->Len=QLen;}
void EnQ1(Q_t *Q, uint8_t val);
bool EnQ (Q_t *Q,uint8_t *data,uint16_t  len);	// queue data block of len bytes
uint16_t  QLen(Q_t *Q);								// get the length of data in q (without dequeuing)
uint16_t  QFree(Q_t *Q);								// get the length free space in q
bool QMT(Q_t *Q);										// get if que is empty
bool DeQ (Q_t *Q,uint8_t *data,uint16_t *len);	// pull the next available data from the queue up to *len bytes
bool DeQ1(Q_t *Q,uint8_t *byte);	// pull the next available byte from the queue
// ******************** end of Que.h *********************************** 	
#endif /* QUE_H_ */
