/**
  ******************************************************************************
  * File Name          : gpio.h
  * Description        : This file contains all the functions prototypes for 
  *                      the gpio  
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __gpio_H
#define __gpio_H
#ifdef __cplusplus
 extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* USER CODE BEGIN Includes */
#include "stm32f4xx.h"
#include "stm32f4xx_gpio.h"
#include "stm32f4xx_rcc.h"

/* USER CODE END Includes */

/* USER CODE BEGIN Private defines */
#define CANEN_GPIO_PORT             GPIOC
#define CAN1EN_PIN                  GPIO_Pin_8
#define CAN2EN_PIN                  GPIO_Pin_9
#define CAN3EN_PIN                  GPIO_Pin_10
#define CANEN_AHB1				   RCC_AHB1Periph_GPIOC

#define LED1_AHB1				   RCC_AHB1Periph_GPIOE
#define LED1_GPIO_PORT             GPIOE
#define LED1_PIN                   GPIO_Pin_0
#define LED2_AHB1				   RCC_AHB1Periph_GPIOE
#define LED2_GPIO_PORT             GPIOE
#define LED2_PIN                   GPIO_Pin_1
#define LED3_AHB1				   RCC_AHB1Periph_GPIOE
#define LED3_GPIO_PORT             GPIOE
#define LED3_PIN                   GPIO_Pin_2
#define RCC_AHB1Periphs				(LED1_AHB1|LED2_AHB1|LED3_AHB1|CANEN_AHB1)


/* USER CODE END Private defines */

void MX_GPIO_Init(void);

/* USER CODE BEGIN Prototypes */
static inline void gpioToggle(GPIO_TypeDef * port, uint16_t pin)
{
	if (port->ODR & pin)
	{
		port->BSRRH |= pin;
	} else
	{
		port->BSRRL |= pin;
	}
}

static inline void gpioSet(GPIO_TypeDef * port, uint16_t pin,uint8_t  On)
{
	if (!On)
	{
		port->BSRRH |= pin;
	} else
	{
		port->BSRRL |= pin;
	}
}

/* USER CODE END Prototypes */

#ifdef __cplusplus
}
#endif
#endif /*__ pinoutConfig_H */

/**
  * @}
  */

/**
  * @}
  */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
