/*
 * NVM.c
 *
 *  Created on: 03/09/2015
 *      Author: kentm
 */

#include <NVM.h>
#include <stdbool.h>
#include <stdint.h>
#include "eeprom.h"

// ******************** defines and typedefs *************************
#define ARRAY_SIZE(arr) (sizeof(arr) / sizeof(arr[0]))
typedef int BoolSizeCheck[(sizeof(bool) != 1) ? -1 : 1];
// ******************** local variables ******************************
NMVVar_t VirtAddVarTab[NVM_Last];
uint16_t VarDataTab[NVM_Last] = {0};

//static EE_Handle_t EEHandle[NVM_Last];
//static const NMVVar_t Defaults[NVM_Last] = NVM_DEFAULTS;
//static NMVVar_t NVMVars[NVM_Last];
// ******************** local function prototypes ********************
// ********************* Implementation ******************************
void InitNVM(void)
{
  for(int i=0;i<ARRAY_SIZE(VirtAddVarTab);i++)
	{
		VirtAddVarTab[i]=i+1;
	}
	FLASH_Unlock();																																// Unlock the Flash Program Erase controller
	while(FLASH_COMPLETE != EE_Init())																																		// EEPROM Init
	{
    __ASM volatile("BKPT #01");
	}
	if(!EE_ReadVariable(VirtAddVarTab[NVM_Format], &VarDataTab[NVM_Format]))	// read eeprom format variable
	{
		if(EEFORMAT != VarDataTab[NVM_Format])																		// if format does not match
		{
			EE_Format();																															// clear the eeprom menory
			while(FLASH_COMPLETE != EE_Init())																						// re-EEPROM Init
			{
		    __ASM volatile("BKPT #01");
			}
		}
	}
}

bool NVMGet(uint8_t  idx,void * val,uint16_t size)
{
	bool Res = false;
	Res = (0==EE_ReadVariable(VirtAddVarTab[idx], &VarDataTab[idx]));
	if(Res)
	{
		switch(size)
		{
			case 1: *((uint8_t *)val) =  VarDataTab[idx];	break;
			case 2: *((uint16_t *)val) = VarDataTab[idx];	break;
			case 4: *((uint32_t *)val) = VarDataTab[idx];	break;
			case 8: *((uint64_t *)val) = VarDataTab[idx];	break;
		}
	}
	else
	{
		switch(size)
		{
			case 1: VarDataTab[idx] = *((uint8_t  *)val);break;
			case 2: VarDataTab[idx] = *((uint16_t *)val);break;
			case 4: VarDataTab[idx] = *((uint32_t *)val);break;
			case 8: VarDataTab[idx] = *((uint64_t *)val);break;
		}
		EE_WriteVariable(VirtAddVarTab[idx],VarDataTab[idx]);												// save eevar
	}
	return(Res);
}

bool NVMSet(uint8_t idx,NMVVar_t val)
{
	bool Result;
	VarDataTab[idx] = val;
	Result = (FLASH_COMPLETE==EE_WriteVariable(VirtAddVarTab[idx],VarDataTab[idx]));// save eevar
	return Result;
}

// ********************* NVM.c *************************************************

